import { AdapterOptions, EnzymeAdapter, RSTNode } from 'enzyme';
import { ReactElement } from 'react';
import { VNode } from 'preact';
import MountRenderer from './MountRenderer';
import ShallowRenderer from './ShallowRenderer';
import StringRenderer from './StringRenderer';
export default class Adapter extends EnzymeAdapter {
    constructor();
    createRenderer(options: AdapterOptions): MountRenderer | ShallowRenderer | StringRenderer;
    nodeToElement(node: RSTNode | string): ReactElement | string;
    nodeToHostNode(node: RSTNode | string): Node | null;
    isValidElement(el: any): boolean;
    createElement(type: string | Function, props: Object, ...children: ReactElement[]): VNode<any>;
    elementToNode(el: ReactElement): RSTNode;
}
