import { MountRenderer as AbstractMountRenderer, RSTNode } from 'enzyme';
import { VNode } from 'preact';
declare type EventDetails = {
    [prop: string]: any;
};
export interface Options {
    /**
     * The container element to render into.
     * If not specified, a detached element (not connected to the body) is used.
     */
    container?: HTMLElement;
}
export default class MountRenderer implements AbstractMountRenderer {
    private _container;
    private _getNode;
    constructor({ container }?: Options);
    render(el: VNode, context?: any, callback?: () => any): void;
    unmount(): void;
    getNode(): RSTNode | null;
    simulateError(nodeHierarchy: RSTNode[], rootNode: RSTNode, error: any): void;
    simulateEvent(node: RSTNode, eventName: string, args?: EventDetails): void;
    batchedUpdates(fn: () => {}): void;
    container(): HTMLElement;
}
export {};
