/**
 * Helper functions to enable this library to work with different versions of
 * Preact.
 */
import { Component, VNode } from 'preact';
/**
 * Add `type` and  `props` properties to Preact elements as aliases of
 * `nodeName` and `attributes`.
 *
 * This only applies to older versions of Preact. Preact 10 uses the
 * names `type` and `props` already.
 *
 * This normalizes VNodes across different versions of Preact and also Enzyme
 * internally depends on the node type and properties object being exposed
 * under these names.
 */
export declare function addTypeAndPropsToVNode(): void;
/**
 * Find the `Component` instance that produced a given DOM node.
 */
export declare function componentForDOMNode(el: Node): Component | null;
export declare function render(el: VNode, container: HTMLElement): void;
/**
 * Return the children of a VNode.
 */
export declare function childElements(el: VNode): (VNode | string | null)[];
