import { Component, VNode } from 'preact';
interface PreactVNode extends VNode {
    __e: Node | null;
    __c: Component | null;
    __k: VNode[] | null;
}
/**
 * Return the last VNode that was rendered into a container using Preact's
 * `render` function.
 */
export declare function getLastVNodeRenderedIntoContainer(container: Node): PreactVNode;
/**
 * Return the VNode returned when `component` was last rendered.
 */
export declare function getLastRenderOutput(component: Component): VNode<{}>[];
/**
 * Return the rendered DOM node associated with a rendered VNode.
 *
 * "Associated" here means either the DOM node directly output as a result of
 * rendering the vnode (for DOM vnodes) or the first DOM node output by a
 * child vnode for component vnodes.
 */
export declare function getDOMNode(node: VNode): Node | null;
/**
 * Return the `Component` instance associated with a rendered VNode.
 */
export declare function getComponent(node: VNode): Component | null;
/**
 * Return the child VNodes associated with a rendered VNode.
 */
export declare function getChildren(node: VNode): VNode<{}>[];
export {};
