/*!
 * @license deepcopy.js Copyright(c) 2013 sasa+1
 * https://github.com/sasaplus1/deepcopy.js
 * Released under the MIT license.
 *
 * type-detect
 * Copyright(c) 2013 jake luer <jake@alogicalparadox.com>
 * MIT Licensed
 */
var commonjsGlobal="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function createCommonjsModule(e,t){return e(t={exports:{}},t.exports),t.exports}var typeDetect=createCommonjsModule(function(e,t){var o,r,n,a,p,y,i,c,f,u,l,s,w,d,m,g,b,S,A,T;e.exports=(o="function"==typeof Promise,r="object"==typeof self?self:commonjsGlobal,n="undefined"!=typeof Symbol,a="undefined"!=typeof Map,p="undefined"!=typeof Set,y="undefined"!=typeof WeakMap,i="undefined"!=typeof WeakSet,c="undefined"!=typeof DataView,f=n&&void 0!==Symbol.iterator,u=n&&void 0!==Symbol.toStringTag,l=p&&"function"==typeof Set.prototype.entries,s=a&&"function"==typeof Map.prototype.entries,w=l&&Object.getPrototypeOf((new Set).entries()),d=s&&Object.getPrototypeOf((new Map).entries()),m=f&&"function"==typeof Array.prototype[Symbol.iterator],g=m&&Object.getPrototypeOf([][Symbol.iterator]()),b=f&&"function"==typeof String.prototype[Symbol.iterator],S=b&&Object.getPrototypeOf(""[Symbol.iterator]()),A=8,T=-1,function(e){var t=typeof e;if("object"!==t)return t;if(null===e)return"null";if(e===r)return"global";if(Array.isArray(e)&&(!1===u||!(Symbol.toStringTag in e)))return"Array";if("object"==typeof window&&null!==window){if("object"==typeof window.location&&e===window.location)return"Location";if("object"==typeof window.document&&e===window.document)return"Document";if("object"==typeof window.navigator){if("object"==typeof window.navigator.mimeTypes&&e===window.navigator.mimeTypes)return"MimeTypeArray";if("object"==typeof window.navigator.plugins&&e===window.navigator.plugins)return"PluginArray"}if(("function"==typeof window.HTMLElement||"object"==typeof window.HTMLElement)&&e instanceof window.HTMLElement){if("BLOCKQUOTE"===e.tagName)return"HTMLQuoteElement";if("TD"===e.tagName)return"HTMLTableDataCellElement";if("TH"===e.tagName)return"HTMLTableHeaderCellElement"}}var n=u&&e[Symbol.toStringTag];if("string"==typeof n)return n;var f=Object.getPrototypeOf(e);return f===RegExp.prototype?"RegExp":f===Date.prototype?"Date":o&&f===Promise.prototype?"Promise":p&&f===Set.prototype?"Set":a&&f===Map.prototype?"Map":i&&f===WeakSet.prototype?"WeakSet":y&&f===WeakMap.prototype?"WeakMap":c&&f===DataView.prototype?"DataView":a&&f===d?"Map Iterator":p&&f===w?"Set Iterator":m&&f===g?"Array Iterator":b&&f===S?"String Iterator":null===f?"Object":Object.prototype.toString.call(e).slice(A,T)})});const isBufferExists="undefined"!=typeof Buffer,isBufferFromExists=isBufferExists&&void 0!==Buffer.from,isBuffer=isBufferExists?function(e){return Buffer.isBuffer(e)}:function(){return!1},copy=isBufferFromExists?function(e){return Buffer.from(e)}:isBufferExists?function(e){return new Buffer(e)}:function(e){return e};function detectType(e){return isBuffer(e)?"Buffer":typeDetect(e)}const collectionTypeSet=new Set(["Arguments","Array","Map","Object","Set"]);function get(e,t,o=null){switch(o||detectType(e)){case"Arguments":case"Array":case"Object":return e[t];case"Map":return e.get(t);case"Set":return t}}function isCollection(e){return collectionTypeSet.has(e)}function set(e,t,o,r=null){switch(r||detectType(e)){case"Arguments":case"Array":case"Object":e[t]=o;break;case"Map":e.set(t,o);break;case"Set":e.add(o)}return e}const globalObject=Function("return this")();function copyArrayBuffer(e){return e.slice(0)}function copyBoolean(e){return new Boolean(e.valueOf())}function copyDataView(e){return new DataView(e.buffer)}function copyBuffer(e){return copy(e)}function copyDate(e){return new Date(e.getTime())}function copyNumber(e){return new Number(e)}function copyRegExp(e){return new RegExp(e.source||"(?:)",e.flags)}function copyString(e){return new String(e)}function copyTypedArray(e,t){return globalObject[t].from(e)}function shallowCopy(e){return e}function getEmptyArray(){return[]}function getEmptyMap(){return new Map}function getEmptyObject(){return{}}function getEmptySet(){return new Set}var copyMap=new Map([["ArrayBuffer",copyArrayBuffer],["Boolean",copyBoolean],["Buffer",copyBuffer],["DataView",copyDataView],["Date",copyDate],["Number",copyNumber],["RegExp",copyRegExp],["String",copyString],["Float32Array",copyTypedArray],["Float64Array",copyTypedArray],["Int16Array",copyTypedArray],["Int32Array",copyTypedArray],["Int8Array",copyTypedArray],["Uint16Array",copyTypedArray],["Uint32Array",copyTypedArray],["Uint8Array",copyTypedArray],["Uint8ClampedArray",copyTypedArray],["Array Iterator",shallowCopy],["Map Iterator",shallowCopy],["Promise",shallowCopy],["Set Iterator",shallowCopy],["String Iterator",shallowCopy],["function",shallowCopy],["global",shallowCopy],["WeakMap",shallowCopy],["WeakSet",shallowCopy],["boolean",shallowCopy],["null",shallowCopy],["number",shallowCopy],["string",shallowCopy],["symbol",shallowCopy],["undefined",shallowCopy],["Arguments",getEmptyArray],["Array",getEmptyArray],["Map",getEmptyMap],["Object",getEmptyObject],["Set",getEmptySet]]);function noop(){}function copy$1(e,t=null,o=noop){2===arguments.length&&"function"==typeof t&&(o=t,t=null);const r=t||detectType(e),n=copyMap.get(r);if("Object"===r){const t=o(e,r);if(void 0!==t)return t}return n?n(e,r):e}function deepcopy(e,t={}){"function"==typeof t&&(t={customizer:t});const{customizer:o}=t,r=detectType(e);if(!isCollection(r))return recursiveCopy(e,null,null,null,o);const n=copy$1(e,r,o);return recursiveCopy(e,n,new WeakMap([[e,n]]),new WeakSet([e]),o)}function recursiveCopy(e,t,o,r,n){const a=detectType(e),p=copy$1(e,a);if(!isCollection(a))return p;let y;switch(a){case"Arguments":case"Array":y=Object.keys(e);break;case"Object":(y=Object.keys(e)).push(...Object.getOwnPropertySymbols(e));break;case"Map":case"Set":y=e.keys()}for(let p of y){const y=get(e,p,a);if(r.has(y))set(t,p,o.get(y),a);else{const e=detectType(y),i=copy$1(y,e);isCollection(e)&&(o.set(y,i),r.add(y)),set(t,p,recursiveCopy(y,i,o,r,n),a)}}return t}export default deepcopy;
